diff -uwr sourceold/scripts/tcw_player.cpp source/scripts/tcw_player.cpp
--- sourceold/scripts/tcw_player.cpp	2011-10-15 12:39:38.266601500 +0800
+++ source/scripts/tcw_player.cpp	2012-02-02 09:44:43.153320300 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011-2012 MP-Gaming
+	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -250,11 +250,11 @@
 
 	//unit purchase sounds
 	int random = Commands->Get_Random_Int(1,3);//used by char purchase playsound
-	if (Commands->Get_Player_Type(obj) == 1)
-	{
 		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Commando") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Commando_Low") == 0) )
 		{
-			if ( (Get_Object_Count(1,"TCW_GDI_Commando") > 1) || (Get_Object_Count(1,"TCW_GDI_Commando_Low") > 1) )
+		if (Commands->Get_Player_Type(obj) == 1)
+		{
+			if ( (Get_Object_Count(1,"TCW_GDI_Commando") > 1) || (Get_Object_Count(1,"TCW_GDI_Commando_Low") > 1) || (Get_Object_Count(1,"TCW_Nod_Commando") > 1) || (Get_Object_Count(1,"TCW_Nod_Commando_Low") > 1) )
 			{
 				Commands->Give_Money(obj,2000.0f,false);
 				Change_Character(obj,"CnC_GDI_MiniGunner_0");
@@ -279,8 +279,8 @@
 				}
 				else if (rnd == 3)
 				{
-					Create_2D_WAV_Sound_Team("purchase_gdi_commando_3.wav",1);
-					char player[250]; sprintf(player,"%s: Let's get this party started.",Get_Player_Name(obj));
+					Create_2D_WAV_Sound_Team("purchase_gdi_commando_5.wav",1);
+					char player[250]; sprintf(player,"%s: Let's load and lock and roll and rock.",Get_Player_Name(obj));
 					Send_Message_Team(1,255,204,0,player);
 				}
 				else if (rnd == 4)
@@ -297,9 +297,57 @@
 				}
 			}
 		}
+		else if (Commands->Get_Player_Type(obj) == 0)
+		{
+			if ( (Get_Object_Count(0,"TCW_GDI_Commando") > 1) || (Get_Object_Count(0,"TCW_GDI_Commando_Low") > 1) || (Get_Object_Count(0,"TCW_Nod_Commando") > 1) || (Get_Object_Count(0,"TCW_Nod_Commando_Low") > 1) )
+			{
+				Commands->Give_Money(obj,2000.0f,false);
+				Change_Character(obj,"CnC_Nod_Minigunner_0");
+			}
+			else
+			{
+				Create_2D_WAV_Sound_Team("gdi_commandodetected.wav",1);
+				Send_Message_Team(1,255,204,0,"Warning, enemy commando detected.");
+
+				int rnd = Commands->Get_Random_Int(1,5);
+				if (rnd == 1)
+				{
+					Create_2D_WAV_Sound_Team("purchase_gdi_commando_1.wav",0);
+					char player[250]; sprintf(player,"%s: Got a present for ya.",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
+				}
+				else if (rnd == 2)
+				{
+					Create_2D_WAV_Sound_Team("purchase_gdi_commando_2.wav",0);
+					char player[250]; sprintf(player,"%s: Okay boss let's hear the plan.",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
+				}
+				else if (rnd == 3)
+				{
+					Create_2D_WAV_Sound_Team("purchase_gdi_commando_5.wav",0);
+					char player[250]; sprintf(player,"%s: Let's load and lock and roll and rock.",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
+				}
+				else if (rnd == 4)
+				{
+					Create_2D_WAV_Sound_Team("purchase_gdi_commando_4.wav",0);
+					char player[250]; sprintf(player,"%s: Didn't miss anything, did i?.",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
+				}
+				else if (rnd == 5)
+				{
+					Create_2D_WAV_Sound_Team("purchase_gdi_commando_5.wav",0);
+					char player[250]; sprintf(player,"%s: Let's load and lock and roll and rock.",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
+				}
+			}
+		}
+	}
 
 		else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Rifle_Squad") == 0)
 		{
+		if (Commands->Get_Player_Type(obj) == 1)
+		{
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_1.wav",1);
@@ -323,6 +371,28 @@
 				Change_Character(obj,"TCW_GDI_Rifle_Upgrade");
 			}
 		}
+		else if (Commands->Get_Player_Type(obj) == 0)
+		{
+			if (random == 1)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_1.wav",0);
+				char player[250]; sprintf(player,"%s: Keep your weapon ready.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+			else if (random == 2)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_2.wav",0);
+				char player[250]; sprintf(player,"%s: Rifle squad ready.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+			else if (random == 3)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_3.wav",0);
+				char player[250]; sprintf(player,"%s: Rifleman awaiting orders.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+		}
+	}
 
 		else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Rifle_Squad_Low") == 0)
 		{
@@ -350,7 +420,9 @@
 			}
 		}
 
-		else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Engineer") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Engineer_Low") == 0) )
+	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Engineer") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Engineer_Low") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Engineer_Coop") == 0) )
+	{
+		if (Commands->Get_Player_Type(obj) == 1)
 		{
 			if (random == 1)
 			{
@@ -371,8 +443,32 @@
 				Send_Message_Team(1,255,204,0,player);
 			}
 		}
+		else if (Commands->Get_Player_Type(obj) == 0)
+		{
+			if (random == 1)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_engineer_1.wav",0);
+				char player[250]; sprintf(player,"%s: I got their codes.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+			else if (random == 2)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_engineer_2.wav",0);
+				char player[250]; sprintf(player,"%s: Engineer clocking in.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+			else if (random == 3)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_engineer_3.wav",0);
+				char player[250]; sprintf(player,"%s: Engineer reporting in.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+		}
+	}
 		else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Grenadier") == 0)
 		{
+		if (Commands->Get_Player_Type(obj) == 1)
+		{
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_1.wav",1);
@@ -396,6 +492,28 @@
 				Change_Character(obj,"TCW_GDI_Grenadier_Upgrade");
 			}
 		}
+		else if (Commands->Get_Player_Type(obj) == 0)
+		{
+			if (random == 1)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_1.wav",0);
+				char player[250]; sprintf(player,"%s: They won't be coming back out.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+			else if (random == 2)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_2.wav",0);
+				char player[250]; sprintf(player,"%s: Somebody call for some blasting?",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+			else if (random == 3)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_3.wav",0);
+				char player[250]; sprintf(player,"%s: Grenade squad all ready.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+		}
+	}
 		else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Grenadier_Low") == 0)
 		{
 			if (random == 1)
@@ -424,6 +542,8 @@
 		
 		else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Missile_Squad") == 0)
 		{
+		if (Commands->Get_Player_Type(obj) == 1)
+		{
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",1);
@@ -447,6 +567,28 @@
 				Change_Character(obj,"TCW_GDI_Missile_Squad_Upgrade");
 			}
 		}
+		else if (Commands->Get_Player_Type(obj) == 0)
+		{
+			if (random == 1)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",0);
+				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+			else if (random == 2)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",0);
+				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+			else if (random == 3)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",0);
+				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+		}
+	}
 		else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Missile_Squad_Low") == 0)
 		{
 			if (random == 1)
@@ -475,9 +617,9 @@
 
 		else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Sniper") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Sniper_Low") == 0) )
 		{
-			if ( (Get_Object_Count(1,"TCW_GDI_Sniper") > sniperlimit) || (Get_Object_Count(1,"TCW_GDI_Sniper_Low") > sniperlimit) )
+		if (Commands->Get_Player_Type(obj) == 1)
 			{
-				if (Is_Base_Powered(1))
+			if ( (Get_Object_Count(1,"TCW_GDI_Sniper") > sniperlimit) || (Get_Object_Count(1,"TCW_GDI_Sniper_Low") > sniperlimit) )
 				{
 					Commands->Give_Money(obj,1000.0f,false);
 					Send_Message_Player(obj,255,204,0,"Sniper limit reached, try again later.");
@@ -486,14 +628,6 @@
 				}
 				else
 				{
-					Commands->Give_Money(obj,2000.0f,false);
-					Send_Message_Player(obj,255,204,0,"Sniper limit reached, try again later.");
-					Create_2D_WAV_Sound_Player(obj,"incmsg.wav");
-					Change_Character(obj,"CnC_GDI_MiniGunner_0");
-				}
-			}
-			else
-			{
 				if (random == 1)
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_sniper_1.wav",1);
@@ -514,8 +648,42 @@
 				}
 			}
 		}
+		else if (Commands->Get_Player_Type(obj) == 0)
+		{
+			if ( (Get_Object_Count(0,"TCW_GDI_Sniper") > sniperlimit) || (Get_Object_Count(1,"TCW_GDI_Sniper_Low") > sniperlimit) )
+			{
+				Commands->Give_Money(obj,1000.0f,false);
+				Send_Message_Player(obj,255,0,0,"Sniper limit reached, try again later.");
+				Create_2D_WAV_Sound_Player(obj,"incmsg.wav");
+				Change_Character(obj,"CnC_Nod_Minigunner_0");
+			}
+			else
+			{
+				if (random == 1)
+				{
+					Create_2D_WAV_Sound_Team("purchase_gdi_sniper_1.wav",0);
+					char player[250]; sprintf(player,"%s: Take 'em out one by one.",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
+				}
+				else if (random == 2)
+				{
+					Create_2D_WAV_Sound_Team("purchase_gdi_sniper_2.wav",0);
+					char player[250]; sprintf(player,"%s: Sniper team ready.",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
+				}
+				else if (random == 3)
+				{
+					Create_2D_WAV_Sound_Team("purchase_gdi_sniper_3.wav",0);
+					char player[250]; sprintf(player,"%s: Sniper team, where do you need us?",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
+				}
+			}
+		}
+	}
 		else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Zonetrooper") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Zonetrooper_Low") == 0) )
 		{
+		if (Commands->Get_Player_Type(obj) == 1)
+		{
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_1.wav",1);
@@ -535,12 +703,33 @@
 				Send_Message_Team(1,255,204,0,player);
 			}
 		}
-	}
 	else if (Commands->Get_Player_Type(obj) == 0)
 	{
-		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Commando") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Commando_Low") == 0) )
+			if (random == 1)
 		{
-			if ( (Get_Object_Count(0,"TCW_Nod_Commando") > 1) || (Get_Object_Count(0,"TCW_Nod_Commando_Low") > 1) )
+				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_1.wav",0);
+				char player[250]; sprintf(player,"%s: Keep 'em coming.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+			else if (random == 2)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_2.wav",0);
+				char player[250]; sprintf(player,"%s: Troopers ready for action.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+			else if (random == 3)
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_3.wav",0);
+				char player[250]; sprintf(player,"%s: Troopers in the field.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
+		}
+	}
+	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Commando") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Commando_Low") == 0) )
+	{
+		if (Commands->Get_Player_Type(obj) == 0)
+		{
+			if ( (Get_Object_Count(0,"TCW_Nod_Commando") > 1) || (Get_Object_Count(0,"TCW_Nod_Commando_Low") > 1) || (Get_Object_Count(0,"TCW_GDI_Commando") > 1) || (Get_Object_Count(0,"TCW_GDI_Commando_Low") > 1) )
 			{
 				Commands->Give_Money(obj,2000.0f,false);
 				Change_Character(obj,"CnC_Nod_Minigunner_0");
@@ -548,7 +737,7 @@
 			else
 			{
 				Create_2D_WAV_Sound_Team("gdi_commandodetected.wav",1);
-				Send_Message_Team(1,248,195,4,"Warning, enemy commando detected.");
+				Send_Message_Team(1,255,204,0,"Warning, enemy commando detected.");
 
 				if (random == 1)
 				{
@@ -570,7 +759,42 @@
 				}
 			}
 		}
-		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Militant_Infantry") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Militant_Infantry_Low") == 0) )
+		else if (Commands->Get_Player_Type(obj) == 1)
+		{
+			if ( (Get_Object_Count(1,"TCW_Nod_Commando") > 1) || (Get_Object_Count(1,"TCW_Nod_Commando_Low") > 1) || (Get_Object_Count(1,"TCW_GDI_Commando") > 1) || (Get_Object_Count(1,"TCW_GDI_Commando_Low") > 1) )
+			{
+				Commands->Give_Money(obj,2000.0f,false);
+				Change_Character(obj,"CnC_GDI_MiniGunner_0");
+			}
+			else
+			{
+				Create_2D_WAV_Sound_Team("nod_commandodetected.wav",0);
+				Send_Message_Team(0,255,0,0,"Warning, enemy commando detected.");
+
+				if (random == 1)
+				{
+					Create_2D_WAV_Sound_Team("purchase_nod_commando_1.wav",1);
+					char player[250]; sprintf(player,"%s: Nice day for a kill.",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
+				}
+				else if (random == 2)
+				{
+					Create_2D_WAV_Sound_Team("purchase_nod_commando_2.wav",1);
+					char player[250]; sprintf(player,"%s: Ready for assignment.",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
+				}
+				else if (random == 3)
+				{
+					Create_2D_WAV_Sound_Team("purchase_nod_commando_2.wav",1);
+					char player[250]; sprintf(player,"%s: Ready for assignment.",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
+				}
+			}
+		}
+	}
+	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Militant_Infantry") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Militant_Infantry_Low") == 0) )
+	{
+		if (Commands->Get_Player_Type(obj) == 0)
 		{
 			if (random == 1)
 			{
@@ -591,7 +815,29 @@
 				Send_Message_Team(0,255,0,0,player);
 			}
 		}
-		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Chem") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Chem_Low") == 0) )
+		else if (Commands->Get_Player_Type(obj) == 1)
+		{
+			if (random == 1)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_militant_squad_1.wav",1);
+				char player[250]; sprintf(player,"%s: Rise up.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,204,0,player);
+			}
+			else if (random == 2)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_militant_squad_2.wav",1);
+				char player[250]; sprintf(player,"%s: The time has come warrior of Nod.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,204,0,player);
+			}
+			else if (random == 3)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_militant_squad_3.wav",1);
+				char player[250]; sprintf(player,"%s: Fighters arm up.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,204,0,player);
+			}
+		}
+	}
+	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Chem") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Chem_Low") == 0) )
 		{
 			if (random == 1)
 			{
@@ -612,7 +858,9 @@
 				Send_Message_Team(0,255,0,0,player);
 			}
 		}
-		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Flame") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Low") == 0) )
+	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Flame") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Black_Hand_Low") == 0) )
+	{
+		if (Commands->Get_Player_Type(obj) == 0)
 		{
 			int rnd = Commands->Get_Random_Int(1,4);
 			if (rnd == 1)
@@ -624,7 +872,7 @@
 			else if (rnd == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_2.wav",0);
-				char player[250]; sprintf(player,"%s: Pure fire ready.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: Purifier ready.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (rnd == 3)
@@ -640,7 +888,38 @@
 				Send_Message_Team(0,255,0,0,player);
 			}
 		}
-		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_RocketGuy") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_RocketGuy_Low") == 0) )
+		else if (Commands->Get_Player_Type(obj) == 1)
+		{
+			int rnd = Commands->Get_Random_Int(1,4);
+			if (rnd == 1)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_1.wav",1);
+				char player[250]; sprintf(player,"%s: One mission. One purpose.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+			else if (rnd == 2)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_2.wav",1);
+				char player[250]; sprintf(player,"%s: Purifier ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+			else if (rnd == 3)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_3.wav",1);
+				char player[250]; sprintf(player,"%s: The flame shall purify.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+			else if (rnd == 4)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_4.wav",1);
+				char player[250]; sprintf(player,"%s: And then there was fire.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+		}
+	}
+	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_RocketGuy") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_RocketGuy_Low") == 0) )
+	{
+		if (Commands->Get_Player_Type(obj) == 0)
 		{
 			if (random == 1)
 			{
@@ -661,7 +940,31 @@
 				Send_Message_Team(0,255,0,0,player);
 			}
 		}
-		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Saboteur") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Saboteur_Low") == 0) )
+		else if (Commands->Get_Player_Type(obj) == 1)
+		{
+			if (random == 1)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_militant_rocket_squad_1.wav",1);
+				char player[250]; sprintf(player,"%s: If it moves: Kill it.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+			else if (random == 2)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_militant_rocket_squad_2.wav",1);
+				char player[250]; sprintf(player,"%s: Rockets ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+			else if (random == 3)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_militant_rocket_squad_3.wav",1);
+				char player[250]; sprintf(player,"%s: We got the rockets.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+		}
+	}
+	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Saboteur") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Saboteur_Low") == 0) )
+	{
+		if (Commands->Get_Player_Type(obj) == 0)
 		{
 			if (random == 1)
 			{
@@ -682,7 +985,31 @@
 				Send_Message_Team(0,255,0,0,player);
 			}
 		}
-		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Shadow") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Shadow_Low") == 0) )
+		if (Commands->Get_Player_Type(obj) == 1)
+		{
+			if (random == 1)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_saboteur_1.wav",1);
+				char player[250]; sprintf(player,"%s: The Brotherhood has entrusted me.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+			else if (random == 2)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_saboteur_2.wav",1);
+				char player[250]; sprintf(player,"%s: Need help with anything?",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+			else if (random == 3)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_saboteur_1.wav",1);
+				char player[250]; sprintf(player,"%s: The Brotherhood has entrusted me.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+		}
+	}
+	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Shadow") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Shadow_Low") == 0) )
+	{
+		if (Commands->Get_Player_Type(obj) == 0)
 		{
 			if (random == 1)
 			{
@@ -703,18 +1030,32 @@
 				Send_Message_Team(0,255,0,0,player);
 			}
 		}
+		else if (Commands->Get_Player_Type(obj) == 1)
+		{
+			if (random == 1)
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_shadow_1.wav",1);
+				char player[250]; sprintf(player,"%s: Quietly.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 	}
-}
-void tcw_Grant_Powerup_Created::Timer_Expired(GameObject *obj, int number)
+			else if (random == 2)
 {
-	if (number == 1003)
+				Create_2D_WAV_Sound_Team("purchase_nod_shadow_2.wav",1);
+				char player[250]; sprintf(player,"%s: Shadow team at your command.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+			else if (random == 3)
 	{
-/*#ifdef SSGM
-	float cmoney = Commands->Get_Money(obj);
-	if (cmoney < MapCredits) { Commands->Give_Money(obj,MapCredits-cmoney,false); } //give the spawn credits everytime they spawn
-#endif*/
+				Create_2D_WAV_Sound_Team("purchase_nod_shadow_2.wav",1);
+				char player[250]; sprintf(player,"%s: Shadow team at your command.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
+		}
 	}
-	else if (number == 1004)//enable stealth again after distance check 
+}
+void tcw_Grant_Powerup_Created::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 1004)//enable stealth again after distance check 
 	{
 		Commands->Enable_Stealth(obj, true);
 		revealed = false;
@@ -750,6 +1091,8 @@
 	{
 		if (param == 1)
 		{
+			if (Commands->Get_ID(sender) != Commands->Get_ID(obj))
+			{
 			kills++;
 			if (kills == 2)
 			{
@@ -809,6 +1152,7 @@
 			}
 		}
 	}
+	}
 	else if (message == 1004)//destealth unit
 	{ 
 		if (param == 1)
@@ -854,10 +1198,10 @@
 			float maxap = Commands->Get_Max_Shield_Strength(obj);
 			float curhp = Commands->Get_Health(obj);
 			float curap = Commands->Get_Shield_Strength(obj);
-			float maxhpnew = maxhp + 15.0f; Set_Max_Health(obj, maxhpnew);
-			float maxapnew = maxap + 15.0f; Set_Max_Shield_Strength(obj, maxapnew);
-			float newhp = curhp + 15.0f; Commands->Set_Health(obj, newhp);
-			float newap = curap + 15.0f; Commands->Set_Shield_Strength(obj, newap);
+			float maxhpnew = maxhp + 30.0f; Set_Max_Health(obj, maxhpnew);
+			float maxapnew = maxap + 30.0f; Set_Max_Shield_Strength(obj, maxapnew);
+			float newhp = curhp + 30.0f; Commands->Set_Health(obj, newhp);
+			float newap = curap + 30.0f; Commands->Set_Shield_Strength(obj, newap);
 			Create_2D_WAV_Sound_Player(obj,"gdi_tech_unit_upgraded.wav");
 			Send_Message_Player(obj,255,204,0,"Unit Upgraded: Composite Armor.");
 		}
diff -uwr sourceold/scripts/tcw_player.h source/scripts/tcw_player.h
--- sourceold/scripts/tcw_player.h	2011-10-15 12:39:38.271484300 +0800
+++ source/scripts/tcw_player.h	2012-02-02 09:44:43.163085900 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011-2012 MP-Gaming
+	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
diff -uwr sourceold/scripts/tcw_powerup.cpp source/scripts/tcw_powerup.cpp
--- sourceold/scripts/tcw_powerup.cpp	2011-10-14 22:25:11.421875000 +0800
+++ source/scripts/tcw_powerup.cpp	2012-02-02 09:44:43.112304600 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011-2012 MP-Gaming
+	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
diff -uwr sourceold/scripts/tcw_powerup.h source/scripts/tcw_powerup.h
--- sourceold/scripts/tcw_powerup.h	2011-10-14 22:27:32.081054600 +0800
+++ source/scripts/tcw_powerup.h	2012-02-02 09:44:43.167968700 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011-2012 MP-Gaming
+	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
